//  Diffusion Client Library for iOS, tvOS and OS X / macOS
//
//  Copyright (c) 2017, 2020 Push Technology Ltd., All Rights Reserved.
//
//  Use is subject to license terms.
//
//  NOTICE: All information contained herein is, and remains the
//  property of Push Technology. The intellectual and technical
//  concepts contained herein are proprietary to Push Technology and
//  may be covered by U.S. and Foreign Patents, patents in process, and
//  are protected by trade secret or copyright law.

@import Foundation;
#import <Diffusion/PTDiffusionMessagingFeature.h>

@class PTDiffusionBytes;
@class PTDiffusionRequest;
@class PTDiffusionRequestHandler;
@class PTDiffusionSessionId;
@class PTDiffusionSessionResponseStream;
@class PTDiffusionTopicTreeRegistration;

/**
 @since 6.0

 @deprecated Since 6.5. This will be removed in a future release. @see PTDiffusionMessagingFeature
 */
DEPRECATED_ATTRIBUTE typedef NS_ENUM(NSInteger, PTDiffusionMessagingControlFeatureErrorCode) {
    /**
     The filter was rejected. The message was not sent to any clients.
     
     @see PTDiffusionUnderlyingErrorsKey
     
     @since 6.0
     */
    PTDiffusionMessagingControlFeatureErrorCode_SendToFilterRejected __deprecated_enum_msg("Will be removed in a future release") = 1,
};

NS_ASSUME_NONNULL_BEGIN

/**
 @since 6.0
 */
extern NSString *const PTDiffusionMessagingControlFeatureErrorDomain;

/**1
 @since 6.0

 @deprecated Since 6.5. Use the PTDiffusionMessagingFeature instead.
 All methods and types have been moved there from this interface which
 will be removed in a future release.

 @see PTDiffusionMessagingFeature
 */
__deprecated_msg("Will be removed in a future release.")
@interface PTDiffusionMessagingControlFeature : PTDiffusionMessagingFeature

/**
 @since 6.0

 @deprecated Since 6.5. This will be removed in a future release.
 Please use [PTDiffusionMessagingFeature addRequestHandler:forPath:sessionProperties:completionHandler] instead.

 @see PTDiffusionMessagingFeature
 */
-(void)addRequestHandler:(PTDiffusionRequestHandler *)handler
                 forPath:(NSString *)path
       sessionProperties:(NSArray<NSString *> *)sessionProperties
       completionHandler:(void (^)(PTDiffusionTopicTreeRegistration * _Nullable registration, NSError * _Nullable error))completionHandler
__deprecated_msg("Will be removed in a future release.");

/**
 @since 6.0

 @deprecated Since 6.5. This will be removed in a future release.
 Please use [PTDiffusionMessagingFeature addRequestHandler:forPath:completionHandler] instead.

 @see PTDiffusionMessagingFeature
 */
-(void)addRequestHandler:(PTDiffusionRequestHandler *)handler
                 forPath:(NSString *)path
       completionHandler:(void (^)(PTDiffusionTopicTreeRegistration * _Nullable registration, NSError * _Nullable error))completionHandler
__deprecated_msg("Will be removed in a future release.");

/**
 @since 6.1

 @deprecated Since 6.5. This will be removed in a future release.
 Please use [PTDiffusionMessagingFeature sendRequest:toFilter:path:responseStream:completionHandler] instead.

 @see PTDiffusionMessagingFeature
 */
-(void)   sendRequest:(PTDiffusionRequest *)request
             toFilter:(NSString *)filter
                 path:(NSString *)path
       responseStream:(PTDiffusionSessionResponseStream *)responseStream
    completionHandler:(void (^)(NSUInteger count, NSError * _Nullable error))completionHandler
__deprecated_msg("Will be removed in a future release.");

@end

NS_ASSUME_NONNULL_END
